## lucene++ 3.0.7

=== src/contrib/CMakeLists.txt ===
project(lucene++-contrib)

file(GLOB_RECURSE contrib_sources
  analyzers/*.cpp
  highlighter/*.cpp
  memory/*.cpp
  snowball/*.cpp
  snowball/libstemmer_c/libstemmer/libstemmer_utf8.c
  snowball/libstemmer_c/src_c/*.c
  snowball/libstemmer_c/runtime/*.c
)

file(GLOB_RECURSE contrib_headers
  "${lucene++-contrib_SOURCE_DIR}/include/*.h"
)

add_definitions(-DLPP_BUILDING_LIB)

include_directories(
  "${lucene++_SOURCE_DIR}/include"
  "${lucene++-lib_SOURCE_DIR}/include"
  "${lucene++-contrib_SOURCE_DIR}/include"
  "${lucene++-contrib_SOURCE_DIR}/snowball/libstemmer_c/include"
  ${Boost_INCLUDE_DIRS}
)

link_directories(
  ${Boost_LIBRARY_DIRS}
)

install(FILES ${contrib_headers}
  DESTINATION
  include/lucene++
  COMPONENT development-contrib
)

add_library(lucene++-contrib SHARED
  ${contrib_sources}
  ${contrib_headers}
)

set_target_properties(lucene++-contrib PROPERTIES
  VERSION ${lucene++_VERSION}
  SOVERSION ${lucene++_SOVERSION}
  COMPILE_FLAGS -DLPP_HAVE_DLL
)

target_link_libraries(lucene++-contrib
  ${CMAKE_THREAD_LIBS_INIT}
  lucene++
)

cotire(lucene++-contrib)

install(TARGETS lucene++-contrib
  DESTINATION "${LIB_DESTINATION}"
  COMPONENT runtime
)

=== src/test/CMakeLists.txt ===
project(lucene++-tester)

add_subdirectory(gtest)

include_directories(
  "${gtest_SOURCE_DIR}/include"
  "${lucene++_SOURCE_DIR}/include"
  "${lucene++-lib_SOURCE_DIR}/include"
  "${lucene++-contrib_SOURCE_DIR}/include"
  "${lucene++-tester_SOURCE_DIR}/include"
  ${Boost_INCLUDE_DIRS}
)

file(GLOB_RECURSE tester_sources
  analysis/*.cpp
  contrib/*.cpp
  document/*.cpp
  index/*.cpp
  main/*.cpp
  queryparser/*.cpp
  search/*.cpp
  store/*.cpp
  util/*.cpp
)

file(GLOB_RECURSE test_headers
  "${lucene++-tester_SOURCE_DIR}/../include/*.h"
  "${lucene++-tester_SOURCE_DIR}/include/*.h"
)

add_definitions(-DLPP_EXPOSE_INTERNAL)

link_directories(
  "${GTEST_LIB_DIR}"
)

add_executable(lucene++-tester
  ${tester_sources}
  ${test_headers}
)

add_dependencies(lucene++-tester
  gtest
)

target_link_libraries(lucene++-tester
  ${CMAKE_THREAD_LIBS_INIT}
  lucene++
  lucene++-contrib
  gtest
  ${lucene_boost_libs}
)

cotire(lucene++-tester)

=== debian/changelog ===
lucene++ (3.0.7-15build2) groovy; urgency=medium

  * Rebuild against new liboost-regex1.71-icu67.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 28 Jul 2020 10:34:00 +0200

lucene++ (3.0.7-15build1) groovy; urgency=medium

  * No change rebuild against new icu ABI.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 27 Jul 2020 16:43:19 +0100

lucene++ (3.0.7-15) unstable; urgency=medium

  * Use a way that should be compatible with -A, -B, and full build,
    working in Debian and Ubuntu

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 03 Jul 2020 18:10:41 +0200

lucene++ (3.0.7-14) unstable; urgency=medium

  * Do the full build also on arch: any.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 03 Jul 2020 14:35:32 +0200

lucene++ (3.0.7-13) unstable; urgency=medium

  * Refactor build to not fail anymore on arch:all
  * Honour nocheck

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 03 Jul 2020 14:02:38 +0200

lucene++ (3.0.7-12) unstable; urgency=medium

  * Add python3 to build-deps to fix arch:all builds

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 03 Jul 2020 13:12:51 +0200

lucene++ (3.0.7-11) unstable; urgency=medium

  [ Debian Janitor ]
  * Bump debhelper from deprecated 9 to 12.
    + debian/rules: Move --fail-missing argument to dh_missing.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Drop unnecessary dh arguments: --parallel

  [ Gianfranco Costamagna ]
  * Upload to sid
  * std-version 4.5.0, compat level 13
  * Add R^3: no

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 03 Jul 2020 12:32:58 +0200

lucene++ (3.0.7-10) unstable; urgency=medium

  * Run testsuite but do not fail.
  * Run testsuite only on arch:any

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 24 Aug 2018 20:47:23 +0200

lucene++ (3.0.7-9) unstable; urgency=medium

  * Move VCS fields to salsa.d.o
  * Bump std-version to 4.2.0.1, no changes required
  * Use secure https link for copyright file
  * Re-enable testsuite

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 23 Aug 2018 17:30:52 +0200

lucene++ (3.0.7-8) unstable; urgency=medium

  * Fix typo, preventing lucene++ from being upgraded.
    (Closes: #794926), thanks Andreas Beckmann for the bug report!

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 08 Aug 2015 10:41:05 +0200

lucene++ (3.0.7-7) unstable; urgency=medium

  * Remove symbols file.
    - It fails on mostly all archs, I'll evaluate again
      the decision after the gcc-5 transition.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 06 Aug 2015 13:34:14 +0200

lucene++ (3.0.7-6) unstable; urgency=medium

  [ Iain Lane ]
  * debian/patches/0001-Fix-compilation-with-Boost-1.58.patch: Cherry-pick
    from upstream to fix compilation with boost 1.58.
  * Update package names for GCC5 ABI break. (Closes: #794716)

  [ Gianfranco Costamagna ]
  * Add symbols files.
  * Update my uid.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 06 Aug 2015 10:45:42 +0200

lucene++ (3.0.7-5) unstable; urgency=medium

  * Use DebWithRelInfo as CMAKE_BUILD_TYPE.
  * Disable testsuite for now, it fails on too many archs.
    - Filed test failures with stack traces upstream.

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Mon, 20 Jul 2015 00:14:44 +0200

lucene++ (3.0.7-4) unstable; urgency=medium

  * d/p/afd772ba14954c8785ce17a376759ba9525f3315.patch:
    - fix segfault when running testsuite
  * d/rules:
    - enable testsuite

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Thu, 16 Jul 2015 18:15:04 +0200

lucene++ (3.0.7-3) unstable; urgency=medium

  * d/p/0001-Fix-packageconfig-path.patch, due to
    an error in CMake the resulting pkg-config file was
    wrong.
  * d/rules: remove ENABLE_STANDARD_ALLOCATOR switch, unused since
    the new version.

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Tue, 28 Apr 2015 09:41:20 +0200

lucene++ (3.0.7-2) unstable; urgency=low

  * Upload to unstable

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Sun, 26 Apr 2015 23:35:23 +0200

lucene++ (3.0.7-1) experimental; urgency=medium

  * New upstream release.
  * d/copyright:
    - Fix copyright issue (upstream issue #70)
      move arabic and persian to BSD license.
    - Remove unicode.LICENSE reference.
    - Add gtest copyright information.
  * d/rules: tweak to follow upstream html documentation move.
  * d/patches: remove every patch, accepted upstream.
  * d/unicode.LICENSE: remove, integrated upstream.
  * d/watch, stop using githubredir.
  * d/control: add VCS-* fields.

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Fri, 30 Jan 2015 17:17:31 +0100

lucene++ (3.0.6-4) unstable; urgency=medium

  * Sigh, using embedded snowball, as per upstream suggestion on issue #71.
    - I think I prefer the snowball/libstemmer to be fully included
      with Lucene++. I vaguely remember making a few tweaks to it to
      fix bugs and make more compatible with Lucene++.

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Sat, 29 Nov 2014 18:13:51 +0100

=== debian/control ===
Source: lucene++
Priority: optional
Maintainer: Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>
Uploaders: Gianfranco Costamagna <locutusofborg@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libboost-date-time-dev,
               libboost-filesystem-dev,
               libboost-iostreams-dev,
               libboost-regex-dev,
               libboost-system-dev,
               libboost-test-dev,
               libboost-thread-dev,
               python3
Build-Depends-Indep: doxygen
Rules-Requires-Root: no
Standards-Version: 4.5.0
Section: libs
Homepage: https://github.com/luceneplusplus/LucenePlusPlus
Vcs-Git: https://salsa.debian.org/debian/luceneplusplus.git
Vcs-Browser: https://salsa.debian.org/debian/luceneplusplus

Package: liblucene++-dev
Section: libdevel
Architecture: any
Depends: liblucene++-contrib0v5 (= ${binary:Version}),
         liblucene++0v5 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Development files for Lucene++
 Lucene++ is an up to date C++ port of the popular Java Lucene
 library, a high-performance, full-featured text search engine.
 .
 This package contains development files.

Package: liblucene++-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Reference manual for Lucene++
 Lucene++ is an up to date C++ port of the popular Java Lucene
 library, a high-performance, full-featured text search engine.
 .
 This package contains the reference manual and examples.

Package: liblucene++0v5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: liblucene++0
Replaces: liblucene++0
Description: Shared library for Lucene++
 Lucene++ is an up to date C++ port of the popular Java Lucene
 library, a high-performance, full-featured text search engine.
 .
 This package contains the shared library.

Package: liblucene++-contrib0v5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: liblucene++-contrib0
Replaces: liblucene++-contrib0
Description: Shared library with Lucene++ contributions
 Lucene++ is an up to date C++ port of the popular Java Lucene
 library, a high-performance, full-featured text search engine.
 .
 This additional contributions include analyzers, a memory-only
 index and a HTML highlighter for search results.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=RelWithDebInfo

override_dh_auto_build-indep:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=RelWithDebInfo -DENABLE_DOCS:BOOL=ON
	dh_auto_build
	dh_auto_build -- doc

override_dh_install-indep:
	dh_install -pliblucene++-doc usr/share/doc/lucene++-doc/* usr/share/doc/liblucene++-doc/
	rm -rf debian/tmp/usr/share/doc/lucene++-doc/

ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
override_dh_auto_test:
	./obj-*/src/test/lucene++-tester || true
endif

override_dh_missing:
	dh_missing --fail-missing

## lucene++ 3.0.8

=== CMakeLists.txt ===
####################################
# init
####################################

cmake_minimum_required(VERSION 3.5)

project(lucene++)

set(lucene++_VERSION_MAJOR 3)
set(lucene++_VERSION_MINOR 0)
set(lucene++_VERSION_PATCH 8)
set(lucene++_SOVERSION "0")

set(lucene++_VERSION
  "${lucene++_VERSION_MAJOR}.${lucene++_VERSION_MINOR}.${lucene++_VERSION_PATCH}")


# set default build type as release
if(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release")
endif()

set(LIB_DESTINATION
  "${CMAKE_INSTALL_FULL_LIBDIR}" CACHE STRING "Define lib output directory name")


####################################
# CMake Modules
####################################

# include specific modules
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(options.cmake)

# pre-compiled headers support
include(cotire)

# if setup using the Toolchain-llvm.cmake file, then use llvm...
if(ENABLE_LLVM)
  include(Toolchain-llvm)
endif()

# fetch dependencies
include(dependencies)

# build docs
include(Lucene++Docs)

# Enable C++11
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

####################################
# platform specific options
####################################
if(WIN32 OR WIN64)
set(CMAKE_DEBUG_POSTFIX "d")
endif()

if(MSVC)
# Disable automatic boost linking on Windows as libraries are added to the linker explicitly
add_definitions(-DBOOST_ALL_NO_LIB)

# enable exceptions, see http://msdn.microsoft.com/en-us/library/1deeycx5.aspx
add_definitions(-EHsc)

# Disable including too many Windows headers
add_definitions(-DWIN32_LEAN_AND_MEAN)

# Disable the min/max macros that conflict with std::min/std::max
add_definitions(-DNOMINMAX)
endif()

if(NOT WIN32 AND NOT CMAKE_SYSTEM MATCHES "SunOS-5*.")
  add_definitions(-fPIC)
endif()

if(CYGWIN)
  add_definitions(-D__LARGE64_FILES)
endif()

if(APPLE)
  set(CMAKE_MACOSX_RPATH ON)
  set(CMAKE_SKIP_BUILD_RPATH FALSE)
  set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
  set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
  list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
  if("${isSystemDir}" STREQUAL "-1")
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
  endif()
endif()


####################################
# custom targets
####################################
configure_file(
  "${CMAKE_MODULE_PATH}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY
)

add_custom_target(
  uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  VERBATIM
)

if(ENABLE_PACKAGING)
  include(CreateLucene++Packages)
endif()


####################################
# bootstrap
####################################

include(TestCXXAcceptsFlag)
include(GNUInstallDirs)

add_subdirectory(include)
add_subdirectory(src)

message("\n\n** Build Summary **")
message("  Version:          ${lucene++_VERSION}")
message("  Prefix:           ${CMAKE_INSTALL_PREFIX}")
message("  Build Type:       ${CMAKE_BUILD_TYPE}")
message("  Architecture:     ${CMAKE_SYSTEM_PROCESSOR}")
message("  System:           ${CMAKE_SYSTEM_NAME}")
message("  Boost Include:    ${Boost_INCLUDE_DIRS}")
message("  Boost Libraries:  ${Boost_LIBRARY_DIRS}")
message("  Zlib Include:     ${ZLIB_INCLUDE_DIRS}")
message("  Zlib Library:     ${ZLIB_LIBRARY_RELEASE}")

=== src/CMakeLists.txt ===

add_subdirectory(core)
add_subdirectory(contrib)
add_subdirectory(config)

if(ENABLE_DEMO)
  add_subdirectory(demo)
endif()

if(ENABLE_TEST)
  enable_testing()
  add_subdirectory(test)
endif()

=== include/config_h/CMakeLists.txt ===
#################################
# set Config.h vars
#################################
if(ENABLE_BOOST_INTEGER)
  set(USE_BOOST_INTEGER "define")
else()
  set(USE_BOOST_INTEGER "undef")
endif()

if(ENABLE_CYCLIC_CHECK)
  set(USE_CYCLIC_CHECK "define")
else()
  set(USE_CYCLIC_CHECK "undef")
endif()


if(LUCENE_BUILD_SHARED)
  set(LPP_SHARED_DLL "define")
else()
  set(LPP_SHARED_DLL "undef")
endif()


#################################
# generate Config.h
#################################
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/Config.h.in"
  "${lucene++_BINARY_DIR}/include/Config.h" @ONLY
)


#################################
# install Config.h
#################################
install(
  FILES 
    "${lucene++_BINARY_DIR}/include/Config.h"
  DESTINATION include/lucene++ )

=== src/config/CMakeLists.txt ===
####################################
# Set config vars
####################################
set(core_libname, "lucene++")
set(contrib_libname, "lucene++-contrib")

set(
    PACKAGE_CMAKE_INSTALL_INCLUDEDIR,
    "${lucene++_INCLUDE_DIR}/lucene++/")

set(
    PACKAGE_CMAKE_INSTALL_LIBDIR,
    "${LIB_INSTALL_DIR}/cmake")


####################################
# include CMakePackageConfigHelpers
####################################
include(CMakePackageConfigHelpers)


####################################
# include directories
####################################
add_subdirectory(core)
add_subdirectory(contrib)

=== src/contrib/CMakeLists.txt ===
project(contrib)

####################################
# create library target
####################################
if (LUCENE_BUILD_SHARED)
  add_library(lucene++-contrib SHARED)
else()
  add_library(lucene++-contrib STATIC)
endif()

add_library(lucene++::lucene++-contrib ALIAS lucene++-contrib)


####################################
# src
####################################
file(GLOB_RECURSE contrib_sources
  "analyzers/*.cpp"
  "highlighter/*.cpp"
  "memory/*.cpp"
  "index/*.cpp"
  "mevc/*.cpp"
  "snowball/*.cpp"
  "snowball/libstemmer_c/libstemmer/libstemmer_utf8.c"
  "snowball/libstemmer_c/src_c/*.c"
  "snowball/libstemmer_c/runtime/*.c"
)

file(GLOB_RECURSE contrib_headers
  "${lucene++-lib_SOURCE_DIR}/include/*.h"
)



target_sources(lucene++-contrib
  PRIVATE
    ${contrib_sources})


####################################
# include directories
####################################
target_include_directories(lucene++-contrib
  PUBLIC
    $<BUILD_INTERFACE:${lucene++_BINARY_DIR}/include>
    $<BUILD_INTERFACE:${lucene++_SOURCE_DIR}/include/lucene++>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${lucene++-contrib_SOURCE_DIR}/snowball/libstemmer_c/include>
    ${Boost_INCLUDE_DIRS}
)



####################################
# dependencies
####################################
target_link_libraries(lucene++-contrib
    Boost::boost
    Boost::date_time
    Boost::filesystem
    Boost::iostreams
    Boost::regex
    Boost::system
    Boost::thread
    ZLIB::ZLIB
    lucene++::lucene++
)

if(WIN32)
    target_link_libraries(lucene++-contrib ws2_32)
endif()


####################################
# link args
####################################
target_compile_options(lucene++-contrib PRIVATE -DLPP_BUILDING_LIB)

set_target_properties(lucene++
  PROPERTIES
    COTIRE_CXX_PREFIX_HEADER_INIT "include/ContribInc.h"
    CXX_VISIBILITY_PRESET hidden
    VISIBILITY_INLINES_HIDDEN 1
    VERSION ${lucene++_VERSION}
    SOVERSION ${lucene++_SOVERSION})
    
cotire(lucene++-contrib)

install(TARGETS lucene++-contrib
  DESTINATION "${LIB_DESTINATION}"
  COMPONENT runtime)

install(
  FILES ${contrib_headers}
  DESTINATION "include/lucene++"
  COMPONENT development-contrib)

=== src/core/CMakeLists.txt ===
project(core)

####################################
# create library target
####################################
if (LUCENE_BUILD_SHARED)
  add_library(lucene++ SHARED)
else()
  add_library(lucene++ STATIC)
endif()

add_library(lucene++::lucene++ ALIAS lucene++)


####################################
# src
####################################
file(GLOB_RECURSE lucene_sources
  "search/*.cpp"
  "analysis/*.cpp"
  "document/*.cpp"
  "index/*.cpp"
  "queryparser/*.cpp"
  "store/*.cpp"
  "util/*.c*"
)

file(GLOB_RECURSE lucene_internal_headers
  "${lucene++-lib_SOURCE_DIR}/include/*.h"
)


target_sources(lucene++
  PRIVATE
    ${lucene_sources}
    ${lucene_internal_headers})


####################################
# include directories
####################################
target_include_directories(lucene++
  PUBLIC
    $<BUILD_INTERFACE:${lucene++_BINARY_DIR}/include>
    $<BUILD_INTERFACE:${lucene++_SOURCE_DIR}/include/lucene++>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    ${Boost_INCLUDE_DIRS})



####################################
# dependencies
####################################
target_link_libraries(lucene++
    Boost::boost
    Boost::date_time
    Boost::filesystem
    Boost::iostreams
    Boost::regex
    Boost::system
    Boost::thread
    ZLIB::ZLIB
)

if(WIN32)
    target_link_libraries(lucene++ ws2_32)
endif()

####################################
# link args
####################################
target_compile_options(lucene++ PRIVATE -DLPP_BUILDING_LIB)

set_target_properties(lucene++
  PROPERTIES
    COTIRE_CXX_PREFIX_HEADER_INIT "include/LuceneInc.h"
    CXX_VISIBILITY_PRESET hidden
    VISIBILITY_INLINES_HIDDEN 1
    VERSION ${lucene++_VERSION}
    SOVERSION ${lucene++_SOVERSION})

cotire(lucene++)


install(TARGETS lucene++
  DESTINATION "${LIB_DESTINATION}"
  COMPONENT runtime)

=== src/test/CMakeLists.txt ===
project(tester)


####################################
# create test bin target
####################################
add_executable(lucene++-tester)


####################################
# configure GTest
####################################
if(MSVC)
  set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
endif()

add_subdirectory(gtest)


####################################
# src
####################################
file(GLOB_RECURSE tester_sources
  "analysis/*.cpp"
  "contrib/*.cpp"
  "document/*.cpp"
  "index/*.cpp"
  "main/*.cpp"
  "queryparser/*.cpp"
  "search/*.cpp"
  "store/*.cpp"
  "util/*.cpp")

file(GLOB_RECURSE test_headers
    "${lucene++-tester_SOURCE_DIR}/include/*.h")

target_sources(lucene++-tester
  PRIVATE
    ${tester_sources})


####################################
# include directories
####################################
target_include_directories(lucene++-tester
  PUBLIC
    $<BUILD_INTERFACE:${googletest_SOURCE_DIR}/googletest/include>
    $<BUILD_INTERFACE:${Boost_INCLUDE_DIRS}>
    $<BUILD_INTERFACE:${lucene++_SOURCE_DIR}/include/lucene++>
    $<BUILD_INTERFACE:${lucene++_BINARY_DIR}/include>
    $<BUILD_INTERFACE:${core_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${contrib_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>)


####################################
# dependencies
####################################
target_link_libraries(lucene++-tester
  PRIVATE
    Boost::boost
    Boost::date_time
    Boost::filesystem
    Boost::iostreams
    Boost::regex
    Boost::system
    Boost::thread
    ZLIB::ZLIB
    gtest_main
    gtest
    
    lucene++::lucene++
    lucene++::lucene++-contrib)


####################################
# link args
####################################
target_compile_options(lucene++-tester PRIVATE -DLPP_EXPOSE_INTERNAL)

cotire(lucene++-tester)

=== src/config/contrib/CMakeLists.txt ===
#################################
# install pkconfig
#################################
if(NOT WIN32)
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/liblucene++-contrib.pc.in"
    "${CMAKE_CURRENT_BINARY_DIR}/liblucene++-contrib.pc" @ONLY)
  
  install(
    FILES
      "${CMAKE_CURRENT_BINARY_DIR}/liblucene++-contrib.pc"
    DESTINATION "include/pkgconfig")
endif()


#################################
# install config.cmake
#################################
configure_package_config_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/liblucene++-contribConfig.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/liblucene++-contribConfig.cmake"
  INSTALL_DESTINATION "${LIB_DESTINATION}/cmake")

write_basic_package_version_file(
  "${CMAKE_CURRENT_BINARY_DIR}/liblucene++-contribConfigVersion.cmake"
  VERSION ${lucene++_VERSION}
  COMPATIBILITY SameMajorVersion )

install(
  FILES
    "${CMAKE_CURRENT_BINARY_DIR}/liblucene++-contribConfig.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/liblucene++-contribConfigVersion.cmake"
  DESTINATION "include/cmake")

=== src/config/core/CMakeLists.txt ===
#################################
# install pkconfig
#################################
if(NOT WIN32)
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/liblucene++.pc.in"
    "${CMAKE_CURRENT_BINARY_DIR}/liblucene++.pc" @ONLY)
  
  install(
    FILES
      "${CMAKE_CURRENT_BINARY_DIR}/liblucene++.pc"
    DESTINATION "include/pkgconfig")
endif()


#################################
# install config.cmake
#################################
configure_package_config_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/liblucene++Config.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/liblucene++Config.cmake"
  INSTALL_DESTINATION "${LIB_DESTINATION}/cmake")

write_basic_package_version_file(
  ${CMAKE_CURRENT_BINARY_DIR}/liblucene++ConfigVersion.cmake
  VERSION ${lucene++_VERSION}
  COMPATIBILITY SameMajorVersion )

install(
  FILES
    "${CMAKE_CURRENT_BINARY_DIR}/liblucene++Config.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/liblucene++ConfigVersion.cmake"
  DESTINATION "include/cmake")

=== debian/changelog ===
lucene++ (3.0.8-5build1) jammy; urgency=medium

  * No-change rebuild against libboost-regex1.74.0-icu70.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 10 Feb 2022 16:00:55 +0100

lucene++ (3.0.8-5) unstable; urgency=medium

  * debian/patches/172.patch:
  * debian/patches/173.patch:
  * debian/patches/174.patch:
    - cherry-pick upstream fixes to install contrib headers
      thanks clay stan <claystan97@gmail.com> for the help
      (Closes: #992483)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 24 Aug 2021 19:17:47 +0200

lucene++ (3.0.8-4) unstable; urgency=medium

  * debian/patches/169.patch:
    - upstream testsuite fix

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 08 Mar 2021 20:45:41 +0100

lucene++ (3.0.8-3) unstable; urgency=medium

  * Also install builddeps in debian/tests/control

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 05 Jan 2021 22:30:20 +0100

lucene++ (3.0.8-2) unstable; urgency=medium

  * Add zlib1g-dev new dependency

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 05 Jan 2021 10:12:21 +0100

lucene++ (3.0.8-1) unstable; urgency=medium

  * New upstream version 3.0.8
  * Drop patch 0001-Fix-compilation-with-Boost-1.58.patch and afd772ba14954c8785ce17a376759ba9525f3315.patch, upstream
  * Also install cmake helpers in libdir
  * Drop useless stuff from installation, gtest is not meant to be installed
  * Add patch to fix an upstream issue with Chinese locale
  * Add upstream-proposed PR to fix a wrong contrib library creation due to a typo
  * Add upstream-proposed patch to fix a bad substitution value for pkgconfig file
  * Add upstream-proposed patch to fix various issues with cmake helpers and substitution files
  * Refresh snowball disabled patch
  * Drop pkgconfig file, use upstream-proposed pr instead
  * Update series file
  * Add autopkgtest trying to build a simple test main with cmake

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 04 Jan 2021 23:53:17 +0100

=== debian/control ===
--- 
+++ 
@@ -11,6 +11,7 @@
                libboost-system-dev,
                libboost-test-dev,
                libboost-thread-dev,
+               zlib1g-dev,
                python3
 Build-Depends-Indep: doxygen
 Rules-Requires-Root: no

=== debian/watch ===
version=3
https://github.com/luceneplusplus/LucenePlusPlus/tags .*/rel_?(\d\S*)\.tar\.gz

## lucene++ 3.0.9

=== src/contrib/CMakeLists.txt ===
--- 
+++ 
@@ -3,11 +3,18 @@
 ####################################
 # create library target
 ####################################
+add_subdirectory(include)
+
 if (LUCENE_BUILD_SHARED)
   add_library(lucene++-contrib SHARED)
 else()
   add_library(lucene++-contrib STATIC)
 endif()
+
+set(lucene++-contrib_SOVERSION "0")
+
+set(lucene++-contrib_VERSION
+  "${lucene++_VERSION_MAJOR}.${lucene++_VERSION_MINOR}.${lucene++_VERSION_PATCH}")
 
 add_library(lucene++::lucene++-contrib ALIAS lucene++-contrib)
 
@@ -27,9 +34,8 @@
   "snowball/libstemmer_c/runtime/*.c"
 )
 
-file(GLOB_RECURSE contrib_headers
-  "${lucene++-lib_SOURCE_DIR}/include/*.h"
-)
+file(GLOB_RECURSE contrib_headers 
+  "${lucene++-lib_SOURCE_DIR}/include/*.h")
 
 
 
@@ -64,8 +70,7 @@
     Boost::system
     Boost::thread
     ZLIB::ZLIB
-    lucene++::lucene++
-)
+    lucene++::lucene++)
 
 if(WIN32)
     target_link_libraries(lucene++-contrib ws2_32)
@@ -77,7 +82,7 @@
 ####################################
 target_compile_options(lucene++-contrib PRIVATE -DLPP_BUILDING_LIB)
 
-set_target_properties(lucene++
+set_target_properties(lucene++-contrib
   PROPERTIES
     COTIRE_CXX_PREFIX_HEADER_INIT "include/ContribInc.h"
     CXX_VISIBILITY_PRESET hidden
@@ -88,7 +93,7 @@
 cotire(lucene++-contrib)
 
 install(TARGETS lucene++-contrib
-  DESTINATION "${LIB_DESTINATION}"
+  DESTINATION ${CMAKE_INSTALL_LIBDIR}
   COMPONENT runtime)
 
 install(

=== src/core/CMakeLists.txt ===
--- 
+++ 
@@ -83,5 +83,5 @@
 
 
 install(TARGETS lucene++
-  DESTINATION "${LIB_DESTINATION}"
+  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
   COMPONENT runtime)

=== src/demo/CMakeLists.txt ===
add_subdirectory(deletefiles)
add_subdirectory(indexfiles)
add_subdirectory(searchfiles)

=== src/config/contrib/CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
   install(
     FILES
       "${CMAKE_CURRENT_BINARY_DIR}/liblucene++-contrib.pc"
-    DESTINATION "include/pkgconfig")
+    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
 endif()
 
 
@@ -19,7 +19,8 @@
 configure_package_config_file(
   "${CMAKE_CURRENT_SOURCE_DIR}/liblucene++-contribConfig.cmake.in"
   "${CMAKE_CURRENT_BINARY_DIR}/liblucene++-contribConfig.cmake"
-  INSTALL_DESTINATION "${LIB_DESTINATION}/cmake")
+  INSTALL_DESTINATION "${LIB_DESTINATION}/cmake/liblucene++-contrib"
+  PATH_VARS contrib_libname PACKAGE_CMAKE_INSTALL_INCLUDEDIR PACKAGE_CMAKE_INSTALL_LIBDIR)
 
 write_basic_package_version_file(
   "${CMAKE_CURRENT_BINARY_DIR}/liblucene++-contribConfigVersion.cmake"
@@ -30,4 +31,4 @@
   FILES
     "${CMAKE_CURRENT_BINARY_DIR}/liblucene++-contribConfig.cmake"
     "${CMAKE_CURRENT_BINARY_DIR}/liblucene++-contribConfigVersion.cmake"
-  DESTINATION "include/cmake")
+  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/liblucene++-contrib")

=== src/config/core/CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
   install(
     FILES
       "${CMAKE_CURRENT_BINARY_DIR}/liblucene++.pc"
-    DESTINATION "include/pkgconfig")
+    DESTINATION "${LIB_DESTINATION}/pkgconfig")
 endif()
 
 
@@ -19,7 +19,8 @@
 configure_package_config_file(
   "${CMAKE_CURRENT_SOURCE_DIR}/liblucene++Config.cmake.in"
   "${CMAKE_CURRENT_BINARY_DIR}/liblucene++Config.cmake"
-  INSTALL_DESTINATION "${LIB_DESTINATION}/cmake")
+  INSTALL_DESTINATION "${LIB_DESTINATION}/cmake/liblucene++"
+  PATH_VARS core_libname PACKAGE_CMAKE_INSTALL_INCLUDEDIR PACKAGE_CMAKE_INSTALL_LIBDIR)
 
 write_basic_package_version_file(
   ${CMAKE_CURRENT_BINARY_DIR}/liblucene++ConfigVersion.cmake
@@ -30,4 +31,4 @@
   FILES
     "${CMAKE_CURRENT_BINARY_DIR}/liblucene++Config.cmake"
     "${CMAKE_CURRENT_BINARY_DIR}/liblucene++ConfigVersion.cmake"
-  DESTINATION "include/cmake")
+  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/liblucene++)

=== src/demo/searchfiles/CMakeLists.txt ===
project(searchfiles)


####################################
# src
####################################
file(GLOB_RECURSE searchfiles_sources
  "${CMAKE_CURRENT_SOURCE_DIR}/main.cpp")

file(GLOB_RECURSE demo_headers
  "${searchfiles_SOURCE_DIR}/../include/*.h")


####################################
# create executable target
####################################
add_executable(searchfiles
  ${searchfiles_sources})


####################################
# include directories
####################################
target_include_directories(searchfiles
  PRIVATE
    $<BUILD_INTERFACE:${lucene++_BINARY_DIR}/include>
    $<BUILD_INTERFACE:${lucene++_SOURCE_DIR}/include/lucene++>
    ${Boost_INCLUDE_DIRS})


####################################
# dependencies
####################################
target_link_libraries(searchfiles
  PRIVATE
    Boost::boost
    Boost::date_time
    Boost::filesystem
    Boost::iostreams
    Boost::regex
    Boost::system
    Boost::thread
    ZLIB::ZLIB
    lucene++::lucene++
    lucene++::lucene++-contrib)

=== debian/changelog ===
lucene++ (3.0.9-9) unstable; urgency=medium

  * Ignore testsuite for now

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 09 Sep 2025 16:05:34 +0200

lucene++ (3.0.9-8) unstable; urgency=medium

  * Cherry-pick 3 other upstream fixes

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 09 Sep 2025 13:11:04 +0200

lucene++ (3.0.9-7) unstable; urgency=medium

  * Back un unversioned boost, with cherry-pick of usptream PR: #210
    and commit c18ead2b0c4aa62af01450cb12353a0baa51411f

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 09 Sep 2025 09:38:06 +0200

lucene++ (3.0.9-6) unstable; urgency=medium

  * Force boost 1.83

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 08 Sep 2025 22:50:59 +0200

lucene++ (3.0.9-5) unstable; urgency=medium

  * Refresh patch
  * Use system googletest
  * Bump std-version to 4.7.2

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 08 Sep 2025 15:22:59 +0200

lucene++ (3.0.9-4) unstable; urgency=medium

  * Ack previous nmus, thanks!
  * Fix build with new cmake (Closes: #1097319)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 08 Sep 2025 15:07:14 +0200

lucene++ (3.0.9-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix build dependency on dpkg-dev (Closes: #1065284)

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 07 Mar 2024 00:22:31 +0100

lucene++ (3.0.9-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add build depedency on dpkg-dev (>= 1.22.5) for time_t transition.
    (Closes: #1065284)

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Mon, 04 Mar 2024 23:42:22 +1300

lucene++ (3.0.9-3) unstable; urgency=medium

  * Upload to sid

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 28 Feb 2024 12:10:42 +0100

lucene++ (3.0.9-2exp1) experimental; urgency=medium

   [ Graham Inggs ]
   * Rename libraries for 64-bit time_t transition.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 28 Feb 2024 12:10:34 +0100

lucene++ (3.0.9-2) unstable; urgency=medium

  * Upload with proposed pull-request 200 to fix build
    failure

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 24 Feb 2024 21:27:13 +0100

lucene++ (3.0.9-1) unstable; urgency=medium

  * New upstream version 3.0.9
  * Drop patches now upstream:
    - {160,161,162,163,169,172,173,174,fix-version-h-install}.patch

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 24 Feb 2024 14:09:18 +0100

lucene++ (3.0.8-8) unstable; urgency=medium

  * Fix another cmake regression

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 19 Jun 2023 21:44:17 +0200

lucene++ (3.0.8-7) unstable; urgency=medium

  [ Debian Janitor ]
  * Apply multi-arch hints.
    + liblucene++-dev: Add Multi-Arch: same.
    + liblucene++-doc: Add Multi-Arch: foreign.

  [ Gianfranco Costamagna ]
  * Fix autopkgtests with newer cmake version

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 19 Jun 2023 15:14:38 +0200

lucene++ (3.0.8-6) unstable; urgency=medium

  [ Debian Janitor ]
  * Update watch file format version to 4.

  [ Gianfranco Costamagna ]
  * Bump std-version to 4.6.2, no changes required
  * Fix version.h installation.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 20 Feb 2023 07:34:36 +0100

=== debian/control ===
Source: lucene++
Priority: optional
Maintainer: Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>
Uploaders: Gianfranco Costamagna <locutusofborg@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5),
               cmake,
               debhelper-compat (= 13),
               libboost-date-time-dev,
               libboost-filesystem-dev,
               libboost-iostreams-dev,
               libboost-regex-dev,
               libboost-system-dev,
               libboost-test-dev,
               libboost-thread-dev,
               libgtest-dev,
               zlib1g-dev,
               python3
Build-Depends-Indep: doxygen
Rules-Requires-Root: no
Standards-Version: 4.7.2
Section: libs
Homepage: https://github.com/luceneplusplus/LucenePlusPlus
Vcs-Git: https://salsa.debian.org/debian/luceneplusplus.git
Vcs-Browser: https://salsa.debian.org/debian/luceneplusplus

Package: liblucene++-dev
Section: libdevel
Architecture: any
Depends: liblucene++-contrib0t64 (= ${binary:Version}),
         liblucene++0t64 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Multi-Arch: same
Description: Development files for Lucene++
 Lucene++ is an up to date C++ port of the popular Java Lucene
 library, a high-performance, full-featured text search engine.
 .
 This package contains development files.

Package: liblucene++-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Reference manual for Lucene++
 Lucene++ is an up to date C++ port of the popular Java Lucene
 library, a high-performance, full-featured text search engine.
 .
 This package contains the reference manual and examples.

Package: liblucene++0t64
Provides: ${t64:Provides}
X-Time64-Compat: liblucene++0v5
Breaks: liblucene++0v5 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: liblucene++0
Replaces: liblucene++0v5, liblucene++0
Description: Shared library for Lucene++
 Lucene++ is an up to date C++ port of the popular Java Lucene
 library, a high-performance, full-featured text search engine.
 .
 This package contains the shared library.

Package: liblucene++-contrib0t64
Provides: ${t64:Provides}
X-Time64-Compat: liblucene++-contrib0v5
Breaks: liblucene++-contrib0v5 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: liblucene++-contrib0
Replaces: liblucene++-contrib0v5, liblucene++-contrib0
Description: Shared library with Lucene++ contributions
 Lucene++ is an up to date C++ port of the popular Java Lucene
 library, a high-performance, full-featured text search engine.
 .
 This additional contributions include analyzers, a memory-only
 index and a HTML highlighter for search results.

=== debian/rules ===
--- 
+++ 
@@ -18,9 +18,16 @@
 	dh_install -pliblucene++-doc usr/share/doc/lucene++-doc/* usr/share/doc/liblucene++-doc/
 	rm -rf debian/tmp/usr/share/doc/lucene++-doc/
 
+override_dh_auto_install:
+	dh_auto_install
+	rm -rf debian/tmp/usr/lib/*/libg*.a
+	rm -rf debian/tmp/usr/lib/*/pkgconfig/g*.pc
+	rm -rf debian/tmp/usr/lib/*/cmake/GTest
+	rm -rf debian/tmp/usr/include/g*
+
 ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
 override_dh_auto_test:
-	./obj-*/src/test/lucene++-tester || true
+	#./obj-*/src/test/lucene++-tester || true
 endif
 
 override_dh_missing:

=== debian/tests/control ===
Tests: cmake-test
Depends: @, @builddeps@, g++, build-essential, cmake

=== debian/watch ===
version=4
https://github.com/luceneplusplus/LucenePlusPlus/tags .*/rel_?(\d\S*)\.tar\.gz
